diff --git a/tests/unit/transport/mixins.py b/tests/unit/transport/mixins.py
index 540cd33d73..a29182a3f3 100644
--- a/tests/unit/transport/mixins.py
+++ b/tests/unit/transport/mixins.py
@@ -9,6 +9,7 @@ import salt.transport.client
 # Import 3rd-party libs
 from salt.ext import six
 import salt.ext.tornado.gen
+import salt.transport.client
 
 
 def run_loop_in_thread(loop, evt):
@@ -30,8 +31,7 @@ def run_loop_in_thread(loop, evt):
         loop.close()
 
 
-class ReqChannelMixin(object):
-
+class ReqChannelMixin:
     def test_basic(self):
         '''
         Test a variety of messages, make sure we get the expected responses
@@ -42,8 +42,8 @@ class ReqChannelMixin(object):
             {'baz': 'qux', 'list': [1, 2, 3]},
         ]
         for msg in msgs:
-            ret = self.channel.send(msg, timeout=2, tries=1)
-            self.assertEqual(ret['load'], msg)
+            ret = self.channel.send(dict(msg), timeout=2, tries=1)
+            self.assertEqual(ret["load"], msg)
 
     def test_normalization(self):
         '''
@@ -57,7 +57,7 @@ class ReqChannelMixin(object):
         ]
         for msg in msgs:
             ret = self.channel.send(msg, timeout=2, tries=1)
-            for k, v in six.iteritems(ret['load']):
+            for k, v in ret["load"].items():
                 self.assertEqual(types[k], type(v))
 
     def test_badload(self):
@@ -70,7 +70,7 @@ class ReqChannelMixin(object):
             self.assertEqual(ret, 'payload and load must be a dict')
 
 
-class PubChannelMixin(object):
+class PubChannelMixin:
     def test_basic(self):
         self.pub = None
 
diff --git a/tests/unit/transport/test_tcp.py b/tests/unit/transport/test_tcp.py
index 6cc29e1414..edf3d9b12e 100644
--- a/tests/unit/transport/test_tcp.py
+++ b/tests/unit/transport/test_tcp.py
@@ -27,6 +27,13 @@ from salt.transport.tcp import SaltMessageClientPool, SaltMessageClient, TCPPubS
 # Import Salt Testing libs
 from tests.support.unit import TestCase, skipIf
 from tests.support.helpers import get_unused_localhost_port, flaky
+from salt.ext.tornado.testing import AsyncTestCase, gen_test
+from salt.transport.tcp import (
+    SaltMessageClient,
+    SaltMessageClientPool,
+    TCPPubServerChannel,
+)
+from tests.support.helpers import flaky, slowTest
 from tests.support.mixins import AdaptedConfigurationTestCaseMixin
 from tests.support.mock import MagicMock, patch
 from tests.unit.transport.mixins import PubChannelMixin, ReqChannelMixin, run_loop_in_thread
@@ -61,11 +68,13 @@ class BaseTCPReqCase(TestCase, AdaptedConfigurationTestCaseMixin):
         )
 
         cls.minion_config = cls.get_temp_config(
-            'minion',
-            **{'transport': 'tcp',
-               'master_ip': '127.0.0.1',
-               'master_port': ret_port,
-               'master_uri': 'tcp://127.0.0.1:{0}'.format(ret_port)}
+            "minion",
+            **{
+                "transport": "tcp",
+                "master_ip": "127.0.0.1",
+                "master_port": ret_port,
+                "master_uri": "tcp://127.0.0.1:{}".format(ret_port),
+            }
         )
 
         cls.process_manager = salt.utils.process.ProcessManager(name='ReqServer_ProcessManager')
@@ -174,12 +183,14 @@ class BaseTCPPubCase(AsyncTestCase, AdaptedConfigurationTestCaseMixin):
         )
 
         cls.minion_config = cls.get_temp_config(
-            'minion',
-            **{'transport': 'tcp',
-               'master_ip': '127.0.0.1',
-               'auth_timeout': 1,
-               'master_port': ret_port,
-               'master_uri': 'tcp://127.0.0.1:{0}'.format(ret_port)}
+            "minion",
+            **{
+                "transport": "tcp",
+                "master_ip": "127.0.0.1",
+                "auth_timeout": 1,
+                "master_port": ret_port,
+                "master_uri": "tcp://127.0.0.1:{}".format(ret_port),
+            }
         )
 
         cls.process_manager = salt.utils.process.ProcessManager(name='ReqServer_ProcessManager')
@@ -216,17 +227,17 @@ class BaseTCPPubCase(AsyncTestCase, AdaptedConfigurationTestCaseMixin):
         del cls.req_server_channel
 
     def setUp(self):
-        super(BaseTCPPubCase, self).setUp()
+        super().setUp()
         self._start_handlers = dict(self.io_loop._handlers)
 
     def tearDown(self):
-        super(BaseTCPPubCase, self).tearDown()
+        super().tearDown()
         failures = []
-        for k, v in six.iteritems(self.io_loop._handlers):
+        for k, v in self.io_loop._handlers.items():
             if self._start_handlers.get(k) != v:
                 failures.append((k, v))
         if failures:
-            raise Exception('FDs still attached to the IOLoop: {0}'.format(failures))
+            raise Exception("FDs still attached to the IOLoop: {}".format(failures))
         del self.channel
         del self._start_handlers
 
@@ -260,7 +271,7 @@ class AsyncPubChannelTest(BaseTCPPubCase, PubChannelMixin):
 
 class SaltMessageClientPoolTest(AsyncTestCase):
     def setUp(self):
-        super(SaltMessageClientPoolTest, self).setUp()
+        super().setUp()
         sock_pool_size = 5
         with patch('salt.transport.tcp.SaltMessageClient.__init__', MagicMock(return_value=None)):
             self.message_client_pool = SaltMessageClientPool({'sock_pool_size': sock_pool_size},
@@ -271,7 +282,7 @@ class SaltMessageClientPoolTest(AsyncTestCase):
     def tearDown(self):
         with patch('salt.transport.tcp.SaltMessageClient.close', MagicMock(return_value=None)):
             del self.original_message_clients
-        super(SaltMessageClientPoolTest, self).tearDown()
+        super().tearDown()
 
     def test_send(self):
         for message_client_mock in self.message_client_pool.message_clients:
@@ -384,66 +395,64 @@ class SaltMessageClientCleanupTest(TestCase, AdaptedConfigurationTestCaseMixin):
 
 
 class TCPPubServerChannelTest(TestCase, AdaptedConfigurationTestCaseMixin):
-    @patch('salt.master.SMaster.secrets')
-    @patch('salt.crypt.Crypticle')
-    @patch('salt.utils.asynchronous.SyncWrapper')
-    def test_publish_filtering(self, sync_wrapper, crypticle, secrets):
-        opts = self.get_temp_config('master')
+    @patch("salt.master.SMaster.secrets")
+    @patch("salt.crypt.Crypticle")
+    def test_publish_filtering(self, crypticle, secrets):
+        opts = self.get_temp_config("master")
         opts["sign_pub_messages"] = False
         channel = TCPPubServerChannel(opts)
 
-        wrap = MagicMock()
         crypt = MagicMock()
         crypt.dumps.return_value = {"test": "value"}
 
         secrets.return_value = {"aes": {"secret": None}}
         crypticle.return_value = crypt
-        sync_wrapper.return_value = wrap
 
         # try simple publish with glob tgt_type
-        channel.publish({"test": "value", "tgt_type": "glob", "tgt": "*"})
-        payload = wrap.send.call_args[0][0]
+        payload = channel.pack_publish(
+            {"test": "value", "tgt_type": "glob", "tgt": "*"}
+        )
 
         # verify we send it without any specific topic
         assert "topic_lst" not in payload
 
         # try simple publish with list tgt_type
-        channel.publish({"test": "value", "tgt_type": "list", "tgt": ["minion01"]})
-        payload = wrap.send.call_args[0][0]
+        payload = channel.pack_publish(
+            {"test": "value", "tgt_type": "list", "tgt": ["minion01"]}
+        )
 
         # verify we send it with correct topic
         assert "topic_lst" in payload
         self.assertEqual(payload["topic_lst"], ["minion01"])
 
         # try with syndic settings
-        opts['order_masters'] = True
-        channel.publish({"test": "value", "tgt_type": "list", "tgt": ["minion01"]})
-        payload = wrap.send.call_args[0][0]
+        opts["order_masters"] = True
+        payload = channel.pack_publish(
+            {"test": "value", "tgt_type": "list", "tgt": ["minion01"]}
+        )
 
         # verify we send it without topic for syndics
         assert "topic_lst" not in payload
 
-    @patch('salt.utils.minions.CkMinions.check_minions')
-    @patch('salt.master.SMaster.secrets')
-    @patch('salt.crypt.Crypticle')
-    @patch('salt.utils.asynchronous.SyncWrapper')
-    def test_publish_filtering_str_list(self, sync_wrapper, crypticle, secrets, check_minions):
-        opts = self.get_temp_config('master')
+    @patch("salt.utils.minions.CkMinions.check_minions")
+    @patch("salt.master.SMaster.secrets")
+    @patch("salt.crypt.Crypticle")
+    def test_publish_filtering_str_list(self, crypticle, secrets, check_minions):
+        opts = self.get_temp_config("master")
         opts["sign_pub_messages"] = False
         channel = TCPPubServerChannel(opts)
 
-        wrap = MagicMock()
         crypt = MagicMock()
         crypt.dumps.return_value = {"test": "value"}
 
         secrets.return_value = {"aes": {"secret": None}}
         crypticle.return_value = crypt
-        sync_wrapper.return_value = wrap
         check_minions.return_value = {"minions": ["minion02"]}
 
         # try simple publish with list tgt_type
-        channel.publish({"test": "value", "tgt_type": "list", "tgt": "minion02"})
-        payload = wrap.send.call_args[0][0]
+        payload = channel.pack_publish(
+            {"test": "value", "tgt_type": "list", "tgt": "minion02"}
+        )
 
         # verify we send it with correct topic
         assert "topic_lst" in payload
diff --git a/tests/unit/transport/test_zeromq.py b/tests/unit/transport/test_zeromq.py
index a68de7c21c..38921465e7 100644
--- a/tests/unit/transport/test_zeromq.py
+++ b/tests/unit/transport/test_zeromq.py
@@ -400,6 +400,7 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
                 ctypes.c_char,
                 six.b(salt.crypt.Crypticle.generate_key_string()),
             ),
+            "serial": multiprocessing.Value(ctypes.c_longlong, lock=False),
         }
         cls.minion_config = cls.get_temp_config(
             'minion',
@@ -448,10 +449,14 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
         sock.connect(pub_uri)
         last_msg = time.time()
         serial = salt.payload.Serial(opts)
-        crypticle = salt.crypt.Crypticle(opts, salt.master.SMaster.secrets['aes']['secret'].value)
+        crypticle = salt.crypt.Crypticle(
+            opts, salt.master.SMaster.secrets["aes"]["secret"].value
+        )
+        unpacker = salt.utils.msgpack.Unpacker()
+        stop = False
         while time.time() - last_msg < timeout:
             try:
-                payload = sock.recv(zmq.NOBLOCK)
+                wire_bytes = sock.recv(zmq.NOBLOCK)
             except zmq.ZMQError:
                 time.sleep(.01)
             else:
@@ -459,13 +464,21 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
                     if messages != 1:
                         messages -= 1
                         continue
-                payload = crypticle.loads(serial.loads(payload)['load'])
-                if 'stop' in payload:
-                    break
-                last_msg = time.time()
-                results.append(payload['jid'])
 
-    @skipIf(salt.utils.platform.is_windows(), 'Skip on Windows OS')
+                unpacker.feed(wire_bytes)
+                for w_payload in unpacker:
+                    payload = crypticle.loads(w_payload[b"load"])
+                    if not payload:
+                        continue
+                    if "stop" in payload:
+                        stop = True
+                        break
+                    last_msg = time.time()
+                    results.append(payload["jid"])
+            if stop:
+                break
+
+    @slowTest
     def test_publish_to_pubserv_ipc(self):
         '''
         Test sending 10K messags to ZeroMQPubServerChannel using IPC transport
@@ -496,6 +509,7 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
         server_channel.pub_close()
         assert len(results) == send_num, (len(results), set(expect).difference(results))
 
+    @slowTest
     def test_zeromq_publish_port(self):
         '''
         test when connecting that we
@@ -576,13 +590,14 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
         Test sending messags to publisher using UDP
         with zeromq_filtering enabled
         '''
-        opts = dict(self.master_config, ipc_mode='ipc',
-                    pub_hwm=0, zmq_filtering=True, acceptance_wait_time=5)
-        server_channel = salt.transport.zeromq.ZeroMQPubServerChannel(opts)
-        server_channel.pre_fork(self.process_manager, kwargs={
-            'log_queue': salt.log.setup.get_multiprocessing_logging_queue()
-        })
-        pub_uri = 'tcp://{interface}:{publish_port}'.format(**server_channel.opts)
+        opts = dict(
+            self.master_config,
+            ipc_mode="ipc",
+            pub_hwm=0,
+            zmq_filtering=True,
+            acceptance_wait_time=5,
+        )
+        pub_uri = "tcp://{interface}:{publish_port}".format(**opts)
         send_num = 1
         expect = []
         results = []
@@ -590,20 +605,47 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
                                   args=(self.minion_config, pub_uri, results,),
                                   kwargs={'messages': 2})
         gather.start()
-        # Allow time for server channel to start, especially on windows
-        time.sleep(2)
-        expect.append(send_num)
-        load = {'tgt_type': 'glob', 'tgt': '*', 'jid': send_num}
-        with patch('salt.utils.minions.CkMinions.check_minions',
-                   MagicMock(return_value={'minions': ['minion'], 'missing': [],
-                                           'ssh_minions': False})):
-            server_channel.publish(load)
-        server_channel.publish(
-            {'tgt_type': 'glob', 'tgt': '*', 'stop': True}
-        )
-        gather.join()
-        server_channel.pub_close()
-        assert len(results) == send_num, (len(results), set(expect).difference(results))
+        with patch(
+            "salt.utils.minions.CkMinions.check_minions",
+            MagicMock(
+                return_value={
+                    "minions": ["minion"],
+                    "missing": [],
+                    "ssh_minions": False,
+                }
+            ),
+        ):
+            # Allow time for server channel to start, especially on windows
+            time.sleep(2)
+            server_channel = salt.transport.zeromq.ZeroMQPubServerChannel(opts)
+            server_channel.pre_fork(
+                self.process_manager,
+                kwargs={
+                    "log_queue": salt.log.setup.get_multiprocessing_logging_queue()
+                },
+            )
+            time.sleep(2)
+            expect.append(send_num)
+            load = {"tgt_type": "glob", "tgt": "*", "jid": send_num}
+            with patch(
+                "salt.utils.minions.CkMinions.check_minions",
+                MagicMock(
+                    return_value={
+                        "minions": ["minion"],
+                        "missing": [],
+                        "ssh_minions": False,
+                    }
+                ),
+            ):
+                server_channel.publish(load)
+            server_channel.publish({"tgt_type": "glob", "tgt": "*", "stop": True})
+            time.sleep(0.3)
+            server_channel.pub_close()
+            gather.join()
+            assert len(results) == send_num, (
+                len(results),
+                set(expect).difference(results),
+            )
 
     def test_publish_to_pubserv_tcp(self):
         '''
@@ -636,7 +678,8 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
         for i in range(num):
             load = {'tgt_type': 'glob', 'tgt': '*', 'jid': '{}-{}'.format(sid, i)}
             server_channel.publish(load)
-        server_channel.close()
+        time.sleep(0.3)
+        server_channel.pub_close()
 
     @staticmethod
     def _send_large(opts, sid, num=10, size=250000 * 3):
@@ -644,7 +687,8 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
         for i in range(num):
             load = {'tgt_type': 'glob', 'tgt': '*', 'jid': '{}-{}'.format(sid, i), 'xdata': '0' * size}
             server_channel.publish(load)
-        server_channel.close()
+        time.sleep(0.3)
+        server_channel.pub_close()
 
     def test_issue_36469_tcp(self):
         '''
@@ -652,19 +696,23 @@ class PubServerChannel(TestCase, AdaptedConfigurationTestCaseMixin):
 
         https://github.com/saltstack/salt/issues/36469
         '''
-        opts = dict(self.master_config, ipc_mode='tcp', pub_hwm=0)
-        server_channel = salt.transport.zeromq.ZeroMQPubServerChannel(opts)
-        server_channel.pre_fork(self.process_manager, kwargs={
-            'log_queue': salt.log.setup.get_multiprocessing_logging_queue()
-        })
+        opts = dict(self.master_config, ipc_mode="tcp", pub_hwm=0)
         send_num = 10 * 4
         expect = []
         results = []
         pub_uri = 'tcp://{interface}:{publish_port}'.format(**opts)
         # Allow time for server channel to start, especially on windows
-        time.sleep(2)
-        gather = threading.Thread(target=self._gather_results, args=(self.minion_config, pub_uri, results,))
+        gather = threading.Thread(
+            target=self._gather_results, args=(self.minion_config, pub_uri, results,)
+        )
         gather.start()
+        time.sleep(2)
+        server_channel = salt.transport.zeromq.ZeroMQPubServerChannel(opts)
+        server_channel.pre_fork(
+            self.process_manager,
+            kwargs={"log_queue": salt.log.setup.get_multiprocessing_logging_queue()},
+        )
+        time.sleep(2)
         with ThreadPoolExecutor(max_workers=4) as executor:
             executor.submit(self._send_small, opts, 1)
             executor.submit(self._send_small, opts, 2)
-- 
2.35.1


